Index: /trunk/LMDZ.GENERIC/libf/phystd/optcv.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/optcv.F90	(revision 304)
+++ /trunk/LMDZ.GENERIC/libf/phystd/optcv.F90	(revision 305)
@@ -1,5 +1,5 @@
       SUBROUTINE OPTCV(DTAUV,TAUV,TAUCUMV,PLEV,  &
           QXVAER,QSVAER,GVAER,WBARV,COSBV,       &
-          TAURAY,TAUAERO,TMID,PMID,TAUGSURF,QVAR)
+          TAURAY,TAUAERO,TMID,PMID,TAUGSURF,QVAR,MUVAR)
 
       use radinc_h
@@ -30,5 +30,5 @@
 !     TLEV(L) - Temperature at the layer boundary
 !     PLEV(L) - Pressure at the layer boundary (i.e. level)
-!     GASV(NT,NPS,NW,NG) - Visual CO2 k-coefficients 
+!     GASV(NT,NPS,NW,NG) - Visible k-coefficients 
 !     
 !-------------------------------------------------------------------
@@ -65,6 +65,6 @@
       real*8 taugsurf(L_NSPECTV,L_NGAUSS-1), TRAYAER
 
-!     Water mixing ratio variables
-      real*8 QVAR(L_LEVELS), WRATIO(L_LEVELS)
+!     Variable species mixing ratio variables
+      real*8 QVAR(L_LEVELS), WRATIO(L_LEVELS), MUVAR(L_LEVELS)
       real*8 KCOEF(4)
       integer NVAR(L_LEVELS)
@@ -74,5 +74,5 @@
 
 !     variables for k in units m^-1
-      double precision wn_cont, p_cont, T_cont
+      double precision wn_cont, p_cont, p_air, T_cont, dtemp
       real*8 dz(L_LEVELS), DCONT
 
@@ -92,8 +92,12 @@
          DPR(k) = PLEV(K)-PLEV(K-1)
 
-         U(k)   = Cmk*DPR(k)
-
          ! if we have continuum opacities, we need dz
-         dz(k)  = dpr(k)*R*TMID(K)/(g*PMID(K))
+         if(kastprof)then
+            dz(k) = dpr(k)*(8314.5/muvar(k))*TMID(K)/(g*PMID(K))
+            U(k)  = (Cmk*mugaz/(muvar(k)))*DPR(k) 
+         else
+            dz(k) = dpr(k)*R*TMID(K)/(g*PMID(K))
+            U(k)  = Cmk*DPR(k)    ! only Cmk line in optci.F
+         endif
 
          call tpindex(PMID(K),TMID(K),QVAR(K),pfgasref,tgasref,WREFVAR, &
@@ -128,22 +132,33 @@
             DCONT = 0.0 ! continuum absorption
 
-            ! include H2 continuum
+            ! include continua if necessary
+            wn_cont = dble(wnov(nw))
+            T_cont  = dble(TMID(k))
             do igas=1,ngasmx
+
+               if(gfrac(igas).eq.-1)then ! variable
+                  p_cont  = dble(PMID(k)*scalep*QVAR(K)) ! qvar = mol/mol
+               else
+                  p_cont  = dble(PMID(k)*scalep*gfrac(igas)*(1.-QVAR(k)))
+               endif
+
+               dtemp=0.0
                if(gnom(igas).eq.'H2_')then 
-
-                  wn_cont = dble(wnov(nw))
-                  T_cont  = dble(TMID(k))
-                  p_cont  = dble(PMID(k)*scalep*gfrac(igas))
-                  call interpolateH2H2(wn_cont,T_cont,p_cont,DCONT,.false.)
-
-                  DCONT=DCONT*dz(k) 
-
-                  if((.not.callgasvis))then
-                     DCONT=0.0
-                  endif
-
-
-               endif
+                  call interpolateH2H2(wn_cont,T_cont,p_cont,dtemp,.false.)
+               elseif(gnom(igas).eq.'H2O'.and.T_cont.gt.200.0)then
+                  p_air = dble(PMID(k)*scalep) - p_cont ! note assumes air!!
+                  call interpolateH2Ocont(wn_cont,T_cont,p_cont,p_air,dtemp,.false.)
+               endif
+
+               DCONT = DCONT + dtemp
+
             enddo
+
+            DCONT = DCONT*dz(k) 
+
+               if((.not.callgasvis))then
+                  DCONT=0.0
+               endif
+
 
             do NG=1,L_NGAUSS-1
@@ -184,4 +199,11 @@
 
                TAUGAS          = U(k)*ANS
+
+               if(graybody)then
+                  TAUGAS = 0.0
+                  DCONT  = 0.0
+               endif
+
+
 
                !TAUGSURF(NW,NG) = TAUGSURF(NW,NG) + TAUGAS
Index: /trunk/LMDZ.GENERIC/libf/phystd/params_h.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/params_h.F90	(revision 305)
+++ /trunk/LMDZ.GENERIC/libf/phystd/params_h.F90	(revision 305)
@@ -0,0 +1,16 @@
+      module params_h
+
+!  for use with kcm subroutines
+!  RDW 22/09/11
+
+      implicit none
+
+      double precision rc,m_n,m_v,rmn
+      save m_n,m_v,rmn
+
+      logical ideal_v
+      save ideal_v
+
+      parameter (rc  = 8.314462d0) ! ideal gas constant [J mol^-1 K^-1]
+
+      end module params_h
